/*****************************************************************************/
// ASKDates̃tH[}bgt@C̃eLXgoCi[ϊ
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>	// exit()
#include "defines.h"
#include "aparam.h"
#include "astdio.h"
#include "adisk.h"	// fd_path
#include "amacro.h"

const char prog[]="@@> ASKDtFmt.C : 1998/08/21 FRI : UTILITY : ASKDtFmt";

/*****************************************************************************/

#define	SINO	0xff	// ʎq

typedef struct {
	unchar	*name;	// ʎq
	short	code;	// ʔԍG$ff͓Ȃ
} SIKIBETU;

SIKIBETU sym[]={
	 {"YYY4",0x01}	// S
	,{"Y2"	,0x02}	// Q
	,{"GG"	,0x03}	// Q
	,{"G2"	,0x03}	// Q
	,{"MM"	,0x04}	// Q
	,{"M2"	,0x04}	// Q
	,{"DD"	,0x05}	// Q
	,{"D2"	,0x05}	// Q
	,{"WE3"	,0x06}	// jpR
	,{"WJ"	,0x07}	// j{P
	,{"H2"	,0x08}	// QS
	,{"H1"	,0x09}	// PQ
	,{"AP"	,0x0a}	// `l^ol
	,{"FF"	,0x0b}	// 
	,{"F2"	,0x0b}	// 
	,{"SS"	,0x0c}	// b
	,{"S2"	,0x0c}	// b
};
#define	SYMS	(sizeof(sym)/sizeof(SIKIBETU))

#define	HEADER	"ASKDates FMT1\x0d\x0a\x1a"
#define	HEADLEN	(sizeof(HEADER)-1)	// EOS͓Ȃ

#define	LMAX	78	// Ps̍őoCg

/*****************************************************************************/

int Txt2Bin(unchar *fntxt,unchar *fnbin)
// eLXgoCiɕϊ
{
FILE *fpt,*fpb;
int ret=0,len,i;
unchar line[LMAX],buff[LMAX],*s,*b,c;
	fpt=fopen(fntxt,"rt");
	if (fpt==NULL) {
		printsn("eLXgt@C܂F",fntxt);
		return(1);
	}
	fpb=fopen(fnbin,"wb");
	if (fpb==NULL) {
		fclose(fpt);
		printsn("oCit@C쐬ł܂F",fnbin);
		return(2);
	}
	// wb_[o
	fwrite(HEADER,HEADLEN,1,fpb);
	// C
	while (!read1line1(fpt,line,LMAX)) { // Psǂݏo
		s=line;
		if (*s==0) continue; // s
		len=1; // ŌEOS̕
		b=buff;
		while ((c=*s++)!=0) {
			if (check_kanji1(c)) { // QoCg
				len+=2;
				if (len>=LMAX) goto LENOVER;
				*b++=c;
				*b++=*s++;
				continue;
			}
			if (c<' ') {
				printsn("Rg[R[hĂ܂:",line);
				ret=4;
				break;
			}
			// ʎq`FbN
			for (i=0;i<SYMS;i++) {
			    unchar *nm;
				nm=sym[i].name;
				if (toupper(c)==*nm) { // 擪Pv
				    int ln;
					ln=strlen(++nm);
					if (memcmpi(s,nm,ln)==0) { // v
						s+=ln; // v΂
						if (++len>=LMAX) goto LENOVER;
						*b++=SINO;
						c=sym[i].code;
						break;
					}
				}
			}
			// ʕł
			if (++len>=LMAX) {
			    LENOVER:;
				printsn("Ps̒܂:",line);
				ret=3;
				break;
			}
			*b++=c;
		}
		*b=0; // End of line
		fwrite(buff,len,1,fpb);
	}
	if (ferror(fpt)) ret=10;
	if (ferror(fpb)) ret=11;
	fclose(fpb);
	fclose(fpt);
	return(ret);
}

/*****************************************************************************/

int BinLook(unchar *fnbin)
// oCi̓e\
{
int ret=0,c,i;
FILE *fpb;
unchar line[LMAX];
	fpb=fopen(fnbin,"rb");
	if (fpb==NULL) {
		printsn("oCit@C܂F",fnbin);
		return(1);
	}
	// wb_[ǂݏo
	fread(line,HEADLEN,1,fpb);
	if (memcmp(line,HEADER,HEADLEN)) {
		printsn("ASKDates̫ϯ޲̧قł͂܂F",fnbin);
		return(2);
	}
	// e\
	//	HEADER
	//	...[00]
	do {
		// Psǂݏo
		while (c=fgetc(fpb),c!=0&&c!=-1) {
			if (c==SINO) {
				c=fgetc(fpb); // ʔԍ
				for (i=0;i<SYMS;i++) {
					if (sym[i].code==c) {
						prints(sym[i].name);
						break;
					}
				}
			} else printc(c);
		}
		crlf();
	} while (c!=-1); // EOF܂
	fclose(fpb);
	return(ret);
}

/*****************************************************************************/

void main(int argc,unchar *argv[])
{
unchar *fntxt,fnbin[MAXPATH];
int i,ret;
int fhelp=0,frev;
	/* IvV`FbN */
	clear_param();
    HELP:;
	if (helpcom(argc,argv,fhelp,"ASKDtFmt","[/B] ÷ [޲[.ask]]")) exit(fhelp? fhelp:255);
	
	/* oCie\[h */
	frev=check_param2("B",argv,argc,0);
	
	/* IvV`FbN */
	i=check_param_error(argv,argc);
	if (i) {
		printsn("\aIvVG[łF",argv[i]);
		exit(1);
	}
	
	// t@C擾
	i=getfname(argc,argv,1,NULL);
	if (i==0) { // t@CȂ
		fhelp=100;
		goto HELP;
	}
	fntxt=argv[i];
	ret=0;
	if (!frev) { // ʏ탂[h
		i=getfname(argc,argv,2,NULL);
		fnget(fnbin,i==0? fntxt:fd_path(argv[i]),"ask");
		printss(fntxt,"");
		printss(fnbin,"\n");
		ret=Txt2Bin(fntxt,fnbin);
	} else { // oCi[e\[h
		ret=BinLook(fntxt);
	}
	exit(ret);
}

/*****************************************************************************/
